#!/usr/bin/perl -w

#=============================================================================#
#                                                                             #
# Name    : Util_Sys module                                                   #
#                                                                             #
# Purpose :                                                                   #
#                                                                             #
# Author  : J. Dousa                                                          #
#                                                                             #
# Created : 31 Mar 2001                                                       #
#                                                                             #
# Changes :                                                                   #
#                                                                             #
#=============================================================================#

package Util_Sys;

use Env;
use File::Basename ( "basename", "dirname", "dirname" );
use File::Path     ( "rmtree", "mkpath" );
use File::Copy     ( "copy"     );
use Gps_Date;
$| = 1;

require Exporter;
$VERSION   = '0.1';
@ISA       = qw( Exporter );
@EXPORT    = qw( &comm_del &comm_cp &comm_mv &comm_md &comm_ln );
 

# Delete array of files with comments
# -----------------------------------
sub comm_del {
  my (@Files) = @_;
  my ($file);
  for $file ( @Files ){
    if( -f $file or -l $file){
      printf " delete $file \n";
      rmtree( "$file" );
    }
  }
}


# Copy the file with comment
# --------------------------
sub comm_cp {
  my ($File1,$File2) = @_;
  my $IRC = 0;

  if( -f "$File1" ){
    if( -l "$File1" && -s "$File2" ){
      printf " *** copy: $File1 is a link ... \n\t   and $File2 exists ! \n";
      return 1;
    }
    if( -d "$File2" ){
      my $Dir2  = "$File2";
      my $File  = basename "$File1";
         $File2 = "$Dir2/$File";
    }
    printf " copy  $File1 $File2 \n";
    copy( "$File1", "$File2" );
  }else{
    printf " *** copy: $File1 does not exist ! \n";
    $IRC = 1;
  }
  return $IRC;
}

# Rename the file with comment
# ----------------------------
sub comm_mv {
  my ($File1,$File2) = @_;  
  my $IRC = 0;


  if( -f "$File1" ){
    if( -l "$File1" && -s "$File2" ){
      printf " *** rename: $File1 is a link ... \n\t   and $File2 exists ! \n";
      return 1;
    }
    if( -d "$File2" ){
      my $Dir2  = "$File2";
      my $File  = basename "$File1";
         $File2 = "$Dir2/$File";
    }
    printf " rename  $File1 $File2 \n";
    # rename $File1 , "$File2" ;
    # the previous command doesn't work in some cases ! ?????
    system( " mv $File1 $File2 " );
  }else{
    printf " *** rename: $File1 does not exist ! \n";
    $IRC = 1;
  }
  return $IRC;
}

# Make directory
# --------------
sub comm_md {
  my( @Dirs ) = @_;  
  my $IRC     = 0 ;
  
  foreach $Dir ( @Dirs ){
    if( ! -d "$Dir" && "$Dir" ne "" ){
      printf " ";
      mkpath( "$Dir", 0774 );
    }
  }
  return $IRC;
}

# Make directory
# --------------
sub comm_ln {
  my( $File, $Link ) = @_;
  my $IRC            = 0 ;

  # remove old file/link
  if( -f "$Link" || -l "$Link" ){ comm_del( "$Link "); }
  
  # check the file for linking
  if( -f "$File" ){
  
    # check the link-directory
    if( -d "$Link" ){
      my $DirL  = "$Link";
      my $Name  =  basename "$File";
         $Link  = "$DirL/$Name";
    }
  
    # check the link-directory
    my( $DirLink ) = dirname( "$Link" );
    if( ! -d "$DirLink" && ! -f "$DirLink"){ comm_md( "$DirLink" )}
    
    # link the file
    printf " ln -s  $File  $Link \n";
#    link( "$File", "$Link" );
    system( "ln -s -f $File $Link" );
    
  }else{
    printf " *** link: $File does not exist ! \n";
    $IRC = 1;
  }
  return $IRC;
}

1;

__END__
 
